#ifndef CODEEDITOR_H
#define CODEEDITOR_H

 #include <QPlainTextEdit>
 #include <QObject>
 #include <QTextCursor>

 class QPaintEvent;
 class QResizeEvent;
 class QSize;
 class QWidget;
 class qdictionnaire;
 class zoneNumeroLigne;


 class codeeditor : public QPlainTextEdit
 {
	 Q_OBJECT

 public:
	 codeeditor(QWidget *parent = 0);
	 void SetPlainText (QString);
	 int LargeurZoneNumeroLigne();
	 void ZoneNumeroLignePaintEvent(QPaintEvent *event);
         void Clear();
         void ReConfigure ();
         QTextCursor m_cursor;



 protected:
	 void resizeEvent(QResizeEvent *event);
     void contextMenuEvent(QContextMenuEvent *event);


 private slots:
	 void NumeroLigne(int newBlockCount);
	 void MiseAjourNumeroLigne(const QRect &, int);
	 void CalculeNombreSyllabes();
	 void AlerteCalculeNombreSyllabes();
         void ControleOrthographe( const QTextCursor & cursor);
         void ActionMenu ( QAction *action );




 private:
         QWidget *ZoneNumeroLigne;
         QMenu *m_menu;
         int TypeAffichageDebutLigne;
	 int NoLigneChangee;
	 QString LigneChangee;
         QHash<QString, int> ListeNbSylText;
         QStringList  ListePhoneme;
         QList<int> ListeNbSyl;
	 int MaxPhoneme;

 signals:
        void AskRime (QString mot) ;
        void AskCitation (QString mot);
        void AskDefinition (QString mot) ;
        void AskConjugaison ( QString mot);


 };


 class zoneNumeroLigne : public QWidget
 {
 public:
	 zoneNumeroLigne(codeeditor *editor) : QWidget(editor) {
		 codeEditor = editor;
	 }

	 QSize sizeHint() const {
		 return QSize(codeEditor->LargeurZoneNumeroLigne(), 0);
	 }

 protected:
	 void paintEvent(QPaintEvent *event) {
		 codeEditor->ZoneNumeroLignePaintEvent(event);
	 }

 private:
	 codeeditor *codeEditor;
 };

#endif // CODEEDITOR_H
