#include "eula.h"
#include "ui_eula.h"

#include <QSettings>

Eula::Eula(QWidget *parent) :
    QDialog(parent),
    m_ui(new Ui::Eula)
{
    m_ui->setupUi(this);
    connect (m_ui->KoButton, SIGNAL(clicked()), this, SLOT(exitApplication()) ) ;
    connect (m_ui->OkCB,SIGNAL(stateChanged(int)),this,SLOT(enabledisableOkButton(int)) );
    connect (m_ui->OkButton, SIGNAL(clicked()), this, SLOT(ContinueInstallation()) ) ;
    m_modeshow=false;
}

void Eula::setModeShow()
{
    m_ui->KoButton->setVisible(false);
    m_ui->OkCB->setVisible(false);
    m_ui->OkButton->setText("Fermer");
    m_ui->OkButton->setEnabled(true);
    m_modeshow=true;

}

Eula::~Eula()
{
    delete m_ui;
}

void Eula::changeEvent(QEvent *e)
{
    switch (e->type()) {
    case QEvent::LanguageChange:
        m_ui->retranslateUi(this);
        break;
    default:
        break;
    }
}

void Eula::enabledisableOkButton( int status)
{
    Q_UNUSED (status);
    if (m_ui->OkCB->checkState() == Qt::Checked ) m_ui->OkButton->setEnabled(true) ;
    else m_ui->OkButton->setEnabled(false);

}
void Eula::ContinueInstallation()
{
    if ( ! m_modeshow )
    {
        QSettings s;
        s.setValue("ConditionAccepted",true) ;
    }
    close();
}

void Eula::exitApplication()
{
    exit(-1);
}
